using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Events;

namespace CarMod
{
    public class CarMod
    {
        public static void Main()
        {
    //Military Truck
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Military Truck",
                    NameToOrderByOverride = "Military Truck",
                    DescriptionOverride = "There is only a place for the driver. You can also put any items in the back of a truck.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Military Truck.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        var body = Instance.transform.GetChild(0);
                        body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -1500f;
                        
                        body.GetComponent<PolygonCollider2D>().pathCount = 3;
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(1.48337913f,1.49948001f),
                            new Vector2(1.46736741f,-0.400269747f),
                            new Vector2(1.58816588f,-0.399389088f),
                            new Vector2(1.58594358f,-0.651694655f),
                            new Vector2(2.584445f,-0.655427694f),
                            new Vector2(2.50020742f,-0.822189569f),
                            new Vector2(2.50572991f,-1.05744195f),
                            new Vector2(2.57554674f,-1.05551648f),
                            new Vector2(2.58832335f,-0.807932317f),
                            new Vector2(3.08125067f,0.183860242f),
                            new Vector2(3.26732063f,0.255227029f),
                            new Vector2(4.68374252f,0.273315489f),
                            new Vector2(4.68694115f,0.732262135f),
                            new Vector2(3.50696516f,0.812515438f),
                            new Vector2(2.83017421f,0.858240902f),
                            new Vector2(2.52719235f,1.50106645f)
                            
                        });
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(2.63868308f,0.919406235f),
                            new Vector2(2.65898776f,-0.380736291f),
                            new Vector2(1.5422039f,-0.356338501f),
                            new Vector2(1.5417304f,1.44274282f),
                            new Vector2(2.38200521f,1.43261933f)
                        });
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(2, new Vector2[]
                        {
                            new Vector2(1.45581174f,0.0307264328f),
                            new Vector2(1.45666957f,-0.415157109f),
                            new Vector2(1.56951499f,-0.414178669f),
                            new Vector2(1.57478404f,-0.5978297f),
                            new Vector2(-4.41614199f,-0.590590417f),
                            new Vector2(-4.41573954f,-0.473322898f),
                            new Vector2(-4.43576384f,-0.475035369f),
                            new Vector2(-4.4796133f,-0.525927901f),
                            new Vector2(-4.5858264f,-0.498373061f),
                            new Vector2(-4.59452724f,-0.415526092f),
                            new Vector2(-4.56058121f,-0.306912959f),
                            new Vector2(-4.59037447f,-0.282453984f),
                            new Vector2(-4.60730839f,-0.181107908f),
                            new Vector2(-4.35202122f,-0.112687111f),
                            new Vector2(-4.351542f,-0.0542266443f),
                            new Vector2(-4.57853365f,-0.0478951931f),
                            new Vector2(-4.57180882f,0.0297181457f)
                        });

                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(3.7135f, -0.7881f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Vechicle/Wheel.png");
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.7285714f;

                        wheels[1].anchor = new Vector2(-0.944f, -0.7881f);
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Vechicle/Wheel.png");
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.7285714f;

                        GameObject wheel = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Car").Prefab.transform.GetChild(1).gameObject);
                        wheel.transform.parent = Instance.transform;
                        wheel.transform.localScale = Vector3.one;
                        wheel.transform.localPosition = new Vector3(-2.8858f, -0.7881f);
                        wheel.AddComponent<AudioSourceTimeScaleBehaviour>();
                        wheel.GetComponent<CircleCollider2D>().radius = 0.7285714f;
                        wheel.GetComponent<SpriteRenderer>().sprite = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Vechicle/Wheel.png");
                        WheelJoint2D wheelJoint = body.gameObject.AddComponent<WheelJoint2D>();
                        wheelJoint.connectedBody = wheel.GetComponent<Rigidbody2D>();
                        wheelJoint.anchor = wheel.transform.localPosition;
                        wheelJoint.motor = wheels[0].motor;
                        wheelJoint.suspension = wheels[0].suspension;
                        wheelJoint.breakForce = wheels[0].breakForce;
                        wheelJoint.useMotor = true;

                        List<WheelJoint2D> wheelList = body.gameObject.GetComponent<CarBehaviour>().WheelJoints.ToList();
                        wheelList.Add(wheelJoint);
                        body.gameObject.GetComponent<CarBehaviour>().WheelJoints = wheelList.ToArray();

                        //wheels[5].anchor = new Vector2(-2.8858f, -0.7881f);
                        //wheels[5].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Vechicle/Wheel.png");
                        //wheels[5].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.7285714f;

                        //var taillight = ModAPI.CreateLight(body, Color.red, 3.5f, 1.5f);
                        //taillight.transform.localPosition = new Vector3(-2.934f, -0.112f);

                        //var bonnet = Instance.transform.GetChild(3);
                        //bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        //bonnet.gameObject.GetComponent<FixedJoint2D>().breakForce = 300f;
                        //bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.9283743f, -0.3900707f);
                        //var limits = new JointAngleLimits2D();
                        //limits.min = 0;
                        //limits.max = 55;
                        //bonnet.gameObject.GetComponent<HingeJoint2D>().limits = limits;
                        //if(body.localPosition == new Vector3(0f, 0f))
                        //{
                            //bonnet.localPosition = new Vector3(3.12852f, -0.128623f);
                        //}
                        //bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        //{
                        //    new Vector2(-0.5345829f, 0.4f),
                        //    new Vector2(-1.014286f, 0.4f),
                         //   new Vector2(-1.012003f, 0.1802728f),
                         //   new Vector2(-0.3898644f, -0.1411351f),
                         //   new Vector2(-0.2047734f, -0.1415623f),
                         //   new Vector2(-0.07092929f, -0.08663893f),
                         //   new Vector2(0.545867f, -0.08511019f),
                        //    new Vector2(0.8657677f, -0.4001054f),
                         //   new Vector2(1.014286f, -0.4f),
                         //   new Vector2(1.014286f, -0.06328857f),
                         //   new Vector2(0.8967597f, 0.07804364f)
                        //});

                        //var headlight = ModAPI.CreateLight(bonnet, Color.white, 3.5f, 1.5f);
                        //headlight.transform.localPosition = new Vector3(0.9874802f, -0.217f);

                        Instance.transform.GetChild(4).gameObject.SetActive(false);

                        var frontDoor = Instance.transform.GetChild(5);                       
                        if(body.localPosition == new Vector3(0f, 0f))
                        {
                            frontDoor.localPosition = new Vector3(2.142f, 0.557f);
                        }
                        //Component.Destroy(frontDoor.GetComponent<PolygonCollider2D>());
                        //frontDoor.gameObject.AddComponent<BoxCollider2D>().size = new Vector2(0.6285715f, 2.457143f);
                        //GetChild(5).gameObject.GetComponent<PolygonCollider2D>().pathCount = 2;
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.558753014f,-0.89459908f),
                            new Vector2(0.540378571f,0.393530071f),
                            new Vector2(0.270829916f,0.898422897f),
                            new Vector2(-0.559109211f,0.894739211f),
                            new Vector2(-0.55738008f,-0.898157954f)
                        });
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-0.471329808f,0.813388169f),
                            new Vector2(0.241425276f,0.813036025f),
                            new Vector2(0.466406822f,0.37739867f),
                            new Vector2(0.468860388f,0.294777334f),
                            new Vector2(-0.471673965f,0.298513472f)
                        });
                        frontDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.542f, 0f);
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";

                        var backDoor = Instance.transform.GetChild(6);
                        if(body.localPosition == new Vector3(0f, 0f)) 
                        {
                            backDoor.localPosition = new Vector3(2.4285f, 0.12855f);
                        }
                        backDoor.gameObject.AddComponent<BoxCollider2D>().size = new Vector2(0.6285715f, 2.457143f);
                        backDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.33f, 0f);

                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(0.9f, 0.9f);
                        if(body.localPosition == new Vector3(0f, 0f))
                        {
                            engine.localPosition = new Vector3(4.053f, 0.4f);
                        }

                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(0.9f, 0.9f);
                        if(body.localPosition == new Vector3(0f, 0f))
                        {
                            GasTank.localPosition = new Vector3(0.634f, -0.388f);
                        }

                        GameObject chair1 = new GameObject("Chair 1");
                        chair1.transform.parent = Instance.transform;
                        chair1.transform.localScale = Vector3.one;
                        chair1.transform.localPosition = new Vector3(1.921f, 0.458f);
                        SpriteRenderer chair1Renderer = chair1.AddComponent<SpriteRenderer>();
                        chair1Renderer.sprite = ModAPI.LoadSprite("Textures/Vechicle/Chair.png");
                        chair1Renderer.sortingLayerName = "Foreground";
                        chair1.layer = LayerMask.NameToLayer("Objects");
                        //chair1.AddComponent<BoxCollider2D>();
                        chair1.AddComponent<Rigidbody2D>().mass = 1f;
                        FixedJoint2D fixedJoint = chair1.AddComponent<FixedJoint2D>();
                        fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        fixedJoint.breakForce = 4000f;
                        chair1.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        chair1.AddComponent<AudioSourceTimeScaleBehaviour>();
                        chair1.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.21810241f,0.847283363f),
                            new Vector2(-0.366803557f,0.834004641f), 
                            new Vector2(-0.405058265f,0.316442192f), 
                            new Vector2(-0.341070056f,-0.149789125f), 
                            new Vector2(-0.331428885f,-0.613728523f), 
                            new Vector2(-0.1999605f,-0.622718871f), 
                            new Vector2(-0.19941327f,-0.842857063f), 
                            new Vector2(0.214381218f,-0.842857122f), 
                            new Vector2(0.214799643f,-0.628531218f), 
                            new Vector2(0.369330138f,-0.550181746f), 
                            new Vector2(0.34207502f,-0.386173487f), 
                            new Vector2(-0.0945902467f,-0.386173487f), 
                            new Vector2(-0.169812024f,0.00809592009f)                              
                        });
                        /*GameObject chair7 = new GameObject("Steering wheel");
                        chair7.transform.parent = Instance.transform;
                        chair7.transform.localScale = Vector3.one;
                        chair7.transform.localPosition = new Vector3(3.1571f, 0.3475f);
                        SpriteRenderer chair7Renderer = chair7.AddComponent<SpriteRenderer>();
                        chair7Renderer.sprite = ModAPI.LoadSprite("Textures/Vechicle/Steering Wheel.png");
                        chair7Renderer.sortingLayerName = "Foreground";
                        chair7.layer = LayerMask.NameToLayer("Objects");
                        //chair1.AddComponent<BoxCollider2D>();
                        chair7.AddComponent<Rigidbody2D>().mass = 1f;
                        FixedJoint2D fixedJoint7 = chair7.AddComponent<FixedJoint2D>();
                        fixedJoint7.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        fixedJoint7.breakForce = 5000f;
                        chair7.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        chair7.AddComponent<AudioSourceTimeScaleBehaviour>();
                        chair7.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.0440748632f, 0.235178307f),
                            new Vector2(-0.114711285f, -0.220722988f),  
                            new Vector2(-0.036367029f, -0.229672536f),    
                            new Vector2(0.100000001f, 0.22857143f)                        
                        });
                        */
                        GameObject Bodyup = new GameObject("Body2");
                        Bodyup.transform.parent = Instance.transform;
                        Bodyup.transform.localScale = Vector3.one;
                        Bodyup.transform.localPosition = new Vector3(-1.907f, 0.699f);
                        SpriteRenderer BodyupRenderer = Bodyup.AddComponent<SpriteRenderer>();
                        BodyupRenderer.sprite = ModAPI.LoadSprite("Textures/Vechicle/Body2.png");
                        BodyupRenderer.sortingLayerName = "Bubbles";
                        Bodyup.layer = LayerMask.NameToLayer("Objects");
                        Bodyup.AddComponent<Rigidbody2D>().mass = 3f;
                        FixedJoint2D fixedJointBodyup = Bodyup.AddComponent<FixedJoint2D>();
                        fixedJointBodyup.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        fixedJointBodyup.breakForce = 10000f;
                        Bodyup.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Bodyup.AddComponent<AudioSourceTimeScaleBehaviour>();
                        var Body2Collider = Bodyup.AddComponent<PolygonCollider2D>();
                        Body2Collider.pathCount = 1;
                        Body2Collider.SetPath(0, new Vector2[]
                        {
                            new Vector2(-2.82857156f,0.671428561f),
                            new Vector2(-2.82857156f,-0.671428561f),  
                            new Vector2(2.82857156f,-0.671428561f),  
                            new Vector2(2.82574892f,0.6732862f),  
                            new Vector2(2.74694872f,0.672642112f),  
                            new Vector2(2.74294519f,-0.585246086f),  
                            new Vector2(-2.74350309f,-0.586987257f),  
                            new Vector2(-2.73091674f,0.670770049f)                      
                        });

                        /*GameObject Bodyup1 = new GameObject("GasTank");
                        Bodyup1.transform.parent = Instance.transform;
                        Bodyup1.transform.localScale = Vector3.one;
                        Bodyup1.transform.localPosition = new Vector3(0.634f, -0.388f);
                        SpriteRenderer Bodyup1Renderer = Bodyup1.AddComponent<SpriteRenderer>();
                        Bodyup1Renderer.sprite = ModAPI.LoadSprite("Textures/Vechicle/Gas Tank.png");
                        Bodyup1Renderer.sortingLayerName = "Bubbles";
                        Bodyup1.layer = LayerMask.NameToLayer("Objects");
                        Bodyup1.AddComponent<Rigidbody2D>().mass = 3f;
                        FixedJoint2D fixedJointBodyup1 = Bodyup1.AddComponent<FixedJoint2D>();
                        fixedJointBodyup1.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        fixedJointBodyup1.breakForce = 10000f;
                        Bodyup1.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        Bodyup1.AddComponent<AudioSourceTimeScaleBehaviour>();
                        Bodyup1.AddComponent<BoxCollider2D>();
                        */
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Vechicle/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Vechicle/Background.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Textures/Vechicle/Door.png");
                        CarSprite1.BackDoor = ModAPI.LoadSprite("Textures/Vechicle/Door.png");
                        //CarSprite1.Bonnet = ModAPI.LoadSprite("Cars/Prison Bus/Type 1/Bonnet.png");
                        //CarSprite1.Boot = ModAPI.LoadSprite("Cars/Prison Bus/Type 1/Boot.png");

                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 3);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1
                        };

                        //var headlightsBehaviour = body.gameObject.GetOrAddComponent<HeadlightsBehaviour>();
                        //headlightsBehaviour.headlights = new GameObject[]
                        //{
                        //    taillight.gameObject,
                        //    headlight.gameObject
                        //};

                        var noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        Instance.transform.GetChild(0).GetChild(0).localPosition = Vector3.zero;
                        //Instance.transform.GetChild(6).gameObject.SetActive(false);
                        foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            {
                                GameObject.Destroy(boxCollider);
                            }
                        GameObject.Destroy(backDoor.gameObject.GetComponent<PolygonCollider2D>());
                        Instance.transform.GetChild(3).gameObject.SetActive(false);

                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
                        Instance.transform.GetChild(6).gameObject.SetActive(false);

                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Vechicle/Gas Tank.png");
                        Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
                        

                    }
                }
            );
        
	    }
    }
    public class FailedCarEngineStartupBehaviour : MonoBehaviour
    {
        private void Start()
        {
            carBehaviour = gameObject.GetComponent<CarBehaviour>();
            audioSources = carBehaviour.audioSourcePosition.gameObject.GetComponents<AudioSource>();
            audioSource = carBehaviour.audioSourcePosition.gameObject.AddComponent<AudioSource>();
            audioSource.spread = 0f;
            audioSource.volume = 1f;
            audioSource.minDistance = 10f;
            audioSource.spatialBlend = 1f;
            audioSource.dopplerLevel = 1f;
            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
        }
        private void Use()
        {
            if(carBehaviour.Activated)
            {
                if((double)UnityEngine.Random.value > chance)
                {
                    audioSources[0].Stop();
                    audioSources[1].Stop();
                    carBehaviour.Activated = false;
                    audioSource.PlayOneShot(FailedEngineStartupSound, 1f);
                }
            }
        }

        private AudioSource audioSource;
        private AudioSource[] audioSources;
        private CarBehaviour carBehaviour;
        public AudioClip FailedEngineStartupSound;
        public double chance;
    }
    public class RandomCarTextureChildBehaviour : MonoBehaviour
    {
        private void Start()
        {
            phys = gameObject.GetComponent<PhysicalBehaviour>();
            renderer = gameObject.GetComponent<SpriteRenderer>();
            randomCarTextures = gameObject.transform.root.gameObject.GetComponentInChildren<RandomCarTextureBehaviour>();
            if(randomCarTextures)
            {
                randomCarTextures.OnAfterChange.AddListener(new UnityAction(SyncSprite));
            }
        }
        private void SyncSprite()
        {
            renderer.sprite = Sprites[randomCarTextures.chosenIndex];
            if(phys)
            {
                phys.RefreshOutline();
            }
        }

        private PhysicalBehaviour phys;
        private SpriteRenderer renderer;
        private RandomCarTextureBehaviour randomCarTextures;
        public Sprite[] Sprites = new Sprite[0];
    }
    public class HeadlightsBehaviour : MonoBehaviour
    {
        private void Start()
        {
            for(int i = 0; i < headlights.Length; i++)
            {
                headlights[i].SetActive(false);
            }
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleHeadlights", delegate()
            {
                if(!Activated)
                {
                    return "Enable headlights";
                }
                return "Disable headlights";
            }, "Toggles headlights", new UnityAction[]
            {
                delegate()
                {
                    Activated = !Activated;
                }
            }));
        }
        private void Update()
        {
            for(int i = 0; i < headlights.Length; i++)
            {
                if(Activated)
                {
                    headlights[i].SetActive(true);
                }
                if(!Activated)
                {
                    headlights[i].SetActive(false);
                }
            }
        }

        public bool Activated;
        public GameObject[] headlights;
    }
    public class RandomHumanTextureBehaviour : MonoBehaviour //credit to mishanya for this behaviour
    {
        public List<Texture2D> Textures = new List<Texture2D>();
        int chosenIndex = 0;
        public PersonBehaviour person;
        ContextMenuButton menuButton;
        public void Start()
        {
            chosenIndex = UnityEngine.Random.Range(0, Textures.Count - -1); 
            ChangeTexture();   
            GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("ChangeTexture", "Change Texture", "Switches to the change human skin", new UnityAction[1]
                 {
                (UnityAction) (() =>
                {
                    ChangeTexture();
                    foreach (var humanSkin in person.Limbs)
                    {
                        if (humanSkin.GetComponent<RandomHumanTextureBehaviour>())
                        {
                           humanSkin.GetComponent<RandomHumanTextureBehaviour>().chosenIndex = chosenIndex;
                        }
                    }

                })
                 }));     
        }
        public void ChangeTexture()
        {
            chosenIndex -= 1;
            if (chosenIndex > Textures.Count - 1)
                chosenIndex = 0;
            person.SetBodyTextures(Textures[chosenIndex]);
        }
    }
    public class TurnSignalsBehaviour : MonoBehaviour
    {
        private void Start()
        {
            UpdateActivation();
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleTurnSignals", delegate()
            {
                if(!Activated)
                {
                    return "Enable turn signals";
                }
                return "Disable turn signals";
            }, "Toggles turn signals", new UnityAction[]
            {
                delegate()
                {
                    Activated = !Activated;
                    UpdateActivation();
                }
            }));
        }
        private void UpdateActivation()
        {
            if(Activated)
            {
                StopAllCoroutines();
                StartCoroutine(Blink());
            }
            else
            {
                for(int i = 0; i < turnSignals.Length; i++)
                {
                    turnSignals[i].SetActive(false);
                }
                StopAllCoroutines();
            }
        }
        private void OnCollisionEnter2D(Collision2D collision)
        {
            if(ActivateOnCollision)
            {
                if(collision.GetContact(0).normalImpulse > BreakingThreshold)
                {
                    Activated = true;
                    UpdateActivation();
                }
            }
        }
        private IEnumerator Blink()
        {
            while(Activated)
            {
                yield return new WaitForSeconds(0.3f);
                for(int i = 0; i < turnSignals.Length; i++)
                {
                    turnSignals[i].SetActive(true);
                }
                yield return new WaitForSeconds(0.3f);
                for(int i = 0; i < turnSignals.Length; i++)
                {
                    turnSignals[i].SetActive(false);
                }
            }
        }

        public bool Activated;
        public bool ActivateOnCollision;
        public GameObject[] turnSignals;
        public float BreakingThreshold = 20f;
    }
    public class ReversingLampBehaviour : MonoBehaviour
    {
        private void Start()
        {
            carBehaviour = gameObject.GetComponent<CarBehaviour>();
            ReversingLamp.SetActive(false);
        }
        private void Update()
        {
            if(carBehaviour.MotorSpeed > 0 && carBehaviour.Activated && !Activated)
            {
                Activated = true;
                ReversingLamp.SetActive(true);
            }
            if(carBehaviour.MotorSpeed < 0 && Activated || !carBehaviour.Activated)
            {
                Activated = false;
                ReversingLamp.SetActive(false);
            }
        }

        public bool Activated;
        public GameObject ReversingLamp;
        private CarBehaviour carBehaviour;
    }
    public class JointBreakDebrisBehaviour : MonoBehaviour
    {
        private void OnJointBreak2D(Joint2D joint)
        {
            if(!Joints.Contains(joint))
            {
                return;
            }
            if(Debris != null && Debris.Length != 0)
            {
                int randomInt = UnityEngine.Random.Range(1, MaxDebrisCount);
                for(int i = 0; i < randomInt; i++)
                {
                    int randomSpriteIndex = UnityEngine.Random.Range(0, Debris.Length);
                    GameObject chip = new GameObject("Chip " + i.ToString());
                    chip.transform.rotation = joint.transform.rotation;
                    chip.transform.position = joint.transform.position + DebrisPositions[Array.IndexOf(Joints, joint)];
                    chip.layer = LayerMask.NameToLayer("Debris");
                    SpriteRenderer chipRenderer = chip.AddComponent<SpriteRenderer>();
                    chipRenderer.sprite = Debris[randomSpriteIndex];
                    chipRenderer.sortingOrder = 2;
                    chipRenderer.sortingLayerName = "Bottom";
                    Rigidbody2D chipRigidbody = chip.AddComponent<Rigidbody2D>();
                    chipRigidbody.angularVelocity = joint.gameObject.GetComponent<Rigidbody2D>().angularVelocity + UnityEngine.Random.Range(-500, 500);
                    chipRigidbody.bodyType = RigidbodyType2D.Dynamic;
                    chipRigidbody.interpolation = Global.CurrentInterpolationMode;
                    chipRigidbody.mass = 0.05f;
                    chipRigidbody.velocity = joint.gameObject.GetComponent<Rigidbody2D>().velocity + UnityEngine.Random.insideUnitCircle * 5f;
                    chip.AddComponent<BoxCollider2D>();
                    chip.AddComponent<DebrisComponent>();
                }
            }
        }

        [SkipSerialisation]
        public Joint2D[] Joints;
        [SkipSerialisation]
        public Sprite[] Debris;
        public int MaxDebrisCount;
        public Vector3[] DebrisPositions;
    }
    public class ShowColliders : MonoBehaviour
    {
        private void Update()
        {
            foreach(Collider2D coll in GetComponents<Collider2D>())
            {
                ModAPI.Draw.Collider(coll);
            }
        }
    }
    public class TowbarBehaviour : MonoBehaviour
    {
        public interface IOnConnected
        {
            void OnConnected(TowbarBehaviour otherTowbar);
        }
        public interface IOnDisconnected
        {
            void OnDisconnected();
        }
        private void Start()
        {
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("disconnect", "Disconnect", "Disconnect", new UnityAction[]
            {
                delegate()
                {
                    Disconnect();
                    connectedTowbar.Disconnect();
                }
            })
            {
                Condition = (() => connectedTowbar)
            });
        }
        private void OnCollisionEnter2D(Collision2D collision)
        {
            if(collision.gameObject.GetComponent<TowbarBehaviour>() && !connectedTowbar && !collision.gameObject.GetComponent<TowbarBehaviour>().connectedTowbar && collision.gameObject.GetComponent<TowbarBehaviour>().IsTrailerTowbar != IsTrailerTowbar)
            {
                connectedTowbar = collision.gameObject.GetComponent<TowbarBehaviour>();
                collision.gameObject.GetComponent<TowbarBehaviour>().connectedTowbar = gameObject.GetComponent<TowbarBehaviour>();
                fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                fixedJoint.breakForce = 40000f;
                fixedJoint.connectedBody = collision.gameObject.GetComponent<Rigidbody2D>();
                fixedJoint.anchor = Anchor;
                fixedJoint.frequency = 10f;
                fixedJoint.dampingRatio = 1f;
                noCollide = gameObject.AddComponent<NoCollide>();
                noCollide.NoCollideSetA = gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                noCollide.NoCollideSetB = collision.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                if(IsTrailerTowbar)
                {
                    gameObject.transform.root.gameObject.GetComponentInChildren<IOnConnected>().OnConnected(connectedTowbar);
                }
                else if(connectedTowbar.IsTrailerTowbar)
                {
                    collision.transform.root.gameObject.GetComponentInChildren<IOnConnected>().OnConnected(this);
                }
            }
        }
        private void OnJointBreak2D(Joint2D joint)
        {
            Disconnect();
            connectedTowbar.Disconnect();
        }
        public void Disconnect()
        {
            if(IsTrailerTowbar)
            {
                gameObject.transform.root.gameObject.GetComponentInChildren<IOnDisconnected>().OnDisconnected();
            }
            else if(connectedTowbar.IsTrailerTowbar)
            {
                connectedTowbar.transform.root.gameObject.GetComponentInChildren<IOnDisconnected>().OnDisconnected();
            }
            if(fixedJoint)
            {
                GameObject.Destroy(fixedJoint);
                GameObject.Destroy(noCollide);
            }
            if(!fixedJoint)
            {
                GameObject.Destroy(connectedTowbar.fixedJoint);
                GameObject.Destroy(connectedTowbar.noCollide);
            }
            connectedTowbar.connectedTowbar = null;
            connectedTowbar = null;
        }

        public bool IsTrailerTowbar = false;
        [SkipSerialisation]
        public CarBehaviour carBehaviour;
        [SkipSerialisation]
        public TowbarBehaviour connectedTowbar;
        [SkipSerialisation]
        public FixedJoint2D fixedJoint;
        [SkipSerialisation]
        public NoCollide noCollide;
        [SkipSerialisation]
        public Vector2 Anchor = Vector2.zero;
    }
    public class TrailerBehaviour : MonoBehaviour, TowbarBehaviour.IOnConnected, TowbarBehaviour.IOnDisconnected
    {
        private void Start()
        {
            originalLimits = Slider.limits;
            phys = gameObject.GetComponent<PhysicalBehaviour>();
            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("disconnect", "Disconnect", "Disconnect", new UnityAction[]
            {
                delegate()
                {
                    TowbarBehaviour.Disconnect();
                    TowbarBehaviour.connectedTowbar.Disconnect();
                }
            })
            {
                Condition = (() => TowbarBehaviour.connectedTowbar)
            });
        }
        public void OnConnected(TowbarBehaviour towbarBehaviour)
        {
            carBehaviour = towbarBehaviour.transform.root.gameObject.GetComponentInChildren<CarBehaviour>();
            List<WheelJoint2D> wheelList = carBehaviour.WheelJoints.ToList();
            wheelList.AddRange(Wheels);
            carBehaviour.WheelJoints = wheelList.ToArray();
            StopAllCoroutines();
            StartCoroutine(MoveSupportFoot(-1f));
        }
        public void OnDisconnected()
        {
            List<WheelJoint2D> wheelList = carBehaviour.WheelJoints.ToList();
            foreach(WheelJoint2D wheel in Wheels)
            {
                float maxMotorTorque = wheel.motor.maxMotorTorque;
                wheel.motor = new JointMotor2D()
                {
                    motorSpeed = 0f,
                    maxMotorTorque = maxMotorTorque
                };
                wheelList.Remove(wheel);
            }
            carBehaviour.WheelJoints = wheelList.ToArray();
            carBehaviour = null;
            StopAllCoroutines();
            StartCoroutine(MoveSupportFoot(1f));
        }
        private IEnumerator MoveSupportFoot(float direction)
        {
            JointLimitState2D limitToWaitFor = (direction > 0f) ? JointLimitState2D.UpperLimit : JointLimitState2D.LowerLimit;
            SetMotorSpeed(direction * Mathf.Abs(gameObject.transform.localScale.x));
            yield return new WaitUntil(() => Slider.limitState == limitToWaitFor);
            SetMotorSpeed(0f);
            yield break;
        }
        private void Update()
        {
            UpdateLimits();
        }
        private void UpdateLimits()
        {
            JointTranslationLimits2D limits = new JointTranslationLimits2D();
            float num = Mathf.Abs(gameObject.transform.localScale.x);
            limits.max = originalLimits.max * num;
            limits.min = originalLimits.min * num;
            Slider.limits = limits;
        }
        private void SetMotorSpeed(float speed)
        {
            JointMotor2D motor = Slider.motor;
            motor.motorSpeed = speed * 1f;
            Slider.motor = motor;
        }

        private PhysicalBehaviour phys;
        [SkipSerialisation]
        private CarBehaviour carBehaviour;
        [SkipSerialisation]
        public TowbarBehaviour TowbarBehaviour;
        [SkipSerialisation]
        public SliderJoint2D Slider;
        [SkipSerialisation]
        public WheelJoint2D[] Wheels;
        private JointTranslationLimits2D originalLimits;
    }
}